/*
 * vim:ts=4:sw=4:et:cindent:cino=(0
 */ 

#ifndef __MAEMO_TWEAKS_MODULE_H__
#define __MAEMO_TWEAKS_MODULE_H__

#include <glib-object.h>

G_BEGIN_DECLS


#define MAEMO_TWEAKS_TYPE_MODULE \
        (maemo_tweaks_module_get_type ())
#define MAEMO_TWEAKS_MODULE(o) \
        (G_TYPE_CHECK_INSTANCE_CAST ((o), MAEMO_TWEAKS_TYPE_MODULE, \
        MaemoTweaksModule))
#define MAEMO_TWEAKS_MODULE_CLASS(k) \
        (G_TYPE_CHECK_CLASS_CAST((k), MAEMO_TWEAKS_TYPE_MODULE, \
        MaemoTweaksModuleClass))
#define MAEMO_TWEAKS_IS_MODULE(o) \
        (G_TYPE_CHECK_INSTANCE_TYPE ((o), MAEMO_TWEAKS_TYPE_MODULE))
#define MAEMO_TWEAKS_IS_MODULE_CLASS(k) \
        (G_TYPE_CHECK_CLASS_TYPE ((k), MAEMO_TWEAKS_TYPE_MODULE))
#define MAEMO_TWEAKS_MODULE_GET_CLASS(o) \
        (G_TYPE_INSTANCE_GET_CLASS ((o), MAEMO_TWEAKS_TYPE_MODULE, \
        MaemoTweaksModuleClass))

typedef struct _MaemoTweaksModule      MaemoTweaksModule;
typedef struct _MaemoTweaksModuleClass MaemoTweaksModuleClass;

struct _MaemoTweaksModule
{
    GTypeModule  parent_instance;

    gchar       *filename;
    GModule     *library;

    /*  module symbols  */
    void (* load)   (MaemoTweaksModule *module);
    void (* unload) (MaemoTweaksModule *module);
};

struct _MaemoTweaksModuleClass
{
    GTypeModuleClass  parent_class;
};

GType maemo_tweaks_module_get_type (void) G_GNUC_CONST;

MaemoTweaksModule * maemo_tweaks_module_new      (const gchar *filename);


/* API for the modules to implement */

void        maemo_tweaks_module_load     (MaemoTweaksModule   *module);
void        maemo_tweaks_module_unload   (MaemoTweaksModule   *module);


G_END_DECLS

#endif /* __MAEMO_TWEAKS_MODULE_H_ */
