/*
 * vim:ts=4:sw=4:et:cindent:cino=(0
 */ 

#include <config.h>
#include <gtk/gtk.h>

#include "maemo-tweaks-section.h"


G_DEFINE_TYPE (MaemoTweaksSection, maemo_tweaks_section, G_TYPE_OBJECT);


static void
maemo_tweaks_section_class_init (MaemoTweaksSectionClass *class)
{
}

static void
maemo_tweaks_section_init (MaemoTweaksSection *section)
{
}

MaemoTweaksSection *
maemo_tweaks_section_new (GType type)
{
    g_return_val_if_fail (g_type_is_a (type, MAEMO_TWEAKS_TYPE_SECTION),
                          NULL);

    return g_object_new (type, NULL);
}

GtkWidget *
maemo_tweaks_section_get_widget (MaemoTweaksSection *section)
{
    g_return_val_if_fail (MAEMO_TWEAKS_IS_SECTION (section), NULL);

    return section->widget;
}

void
maemo_tweaks_section_save (MaemoTweaksSection *section,
                           gboolean *requires_restart)
{
    g_return_if_fail (MAEMO_TWEAKS_IS_SECTION (section));

    if (MAEMO_TWEAKS_SECTION_GET_CLASS (section)->save)
        MAEMO_TWEAKS_SECTION_GET_CLASS (section)->save (section,
                                                        requires_restart);
    else
        g_warning ("%s: section class %s doesn't implement "
                   "MaemoTweaksSection::filter ()\n",
                   G_STRFUNC, g_type_name (G_TYPE_FROM_INSTANCE (section)));
}

