/*
 * vim:ts=4:sw=4:et:cindent:cino=(0
 */ 

#ifndef __MAEMO_TWEAKS_SECTION_H__
#define __MAEMO_TWEAKS_SECTION_H__

#include <glib-object.h>

G_BEGIN_DECLS


#define MAEMO_TWEAKS_TYPE_SECTION \
        (maemo_tweaks_section_get_type ())
#define MAEMO_TWEAKS_SECTION(o) \
        (G_TYPE_CHECK_INSTANCE_CAST ((o), MAEMO_TWEAKS_TYPE_SECTION, \
        MaemoTweaksSection))
#define MAEMO_TWEAKS_SECTION_CLASS(k) \
        (G_TYPE_CHECK_CLASS_CAST((k), MAEMO_TWEAKS_TYPE_SECTION, \
        MaemoTweaksSectionClass))
#define MAEMO_TWEAKS_IS_SECTION(o) \
        (G_TYPE_CHECK_INSTANCE_TYPE ((o), MAEMO_TWEAKS_TYPE_SECTION))
#define MAEMO_TWEAKS_IS_SECTION_CLASS(k) \
        (G_TYPE_CHECK_CLASS_TYPE ((k), MAEMO_TWEAKS_TYPE_SECTION))
#define MAEMO_TWEAKS_SECTION_GET_CLASS(o) \
        (G_TYPE_INSTANCE_GET_CLASS ((o), MAEMO_TWEAKS_TYPE_SECTION, \
        MaemoTweaksSectionClass))


typedef struct _MaemoTweaksSection      MaemoTweaksSection;
typedef struct _MaemoTweaksSectionClass MaemoTweaksSectionClass;

struct _MaemoTweaksSection
{
    GObject  parent_instance;

    /* The widget that the section populates (usually a vbox */
    GtkWidget *widget;
};

struct _MaemoTweaksSectionClass
{
    GObjectClass  parent_class;

    const gchar *name;

    void (*save) (MaemoTweaksSection *section, gboolean *requires_restart);
};


GType maemo_tweaks_section_get_type (void) G_GNUC_CONST;

MaemoTweaksSection * maemo_tweaks_section_new (GType type);

GtkWidget * maemo_tweaks_section_get_widget (MaemoTweaksSection *section);
void maemo_tweaks_section_save (MaemoTweaksSection *section,
                                gboolean *requires_restart);

G_END_DECLS

#endif /* __MAEMO_TWEAKS_SECTION_H_ */

